// Dualis
// (c) Mic 2006
//
// Functions and data are scattered all over the place. Have fun..


// Windows Header Files:
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <winuser.h>

// C RunTime Header Files
#include <stdlib.h>
#include <malloc.h>
#include <memory.h>
#include <tchar.h>

#include "CEventQueue.h"
#include "CMenu.h"
#include "CScrollBar.h"

#include "avigenerator.h"
#include "dialogs.h"
#include "dualis.h"
#include "tabs.h"
#include "beeampee.h"
#include "resource.h"
#include "zombie.h"
#include "disarm.h"
#include "ndsfile.h"
#include "mspal.h"
#include "ioregs.h"
#include "ipc.h"
#include "unzip.h"



// Menuitem enumerators
#define IDM_ROM_INFO					1003
#define IDM_CLOSE						1004
#define IDM_SCREENSHOT					1005
#define IDM_EXIT						1012

#define IDM_RUN							1101
#define IDM_PAUSE						1102
#define IDM_RESET						1103

#define IDM_ABOUT						1301

#define IDC_MAINSCR						1901
#define IDC_SUBSCR						1902

#define IDC_MEMCOMBO					1950


#define FRAMES_PER_SECOND	60.0f


#define WINERROR(message) wsprintf(szBuffer,"%s\nError code = %08X.",message,GetLastError()); \
	                      MessageBox(NULL,szBuffer,"Error",MB_ICONERROR)

#define COMMDLGERROR(message) wsprintf(szBuffer,"%s\nError code = %08X.",message,CommDlgExtendedError()); \
	                      MessageBox(NULL,szBuffer,"Error",MB_ICONERROR)

#define WINPRINT(fmtstr,val) wsprintf(szBuffer,fmtstr,val); \
	                         WriteConsole(hOut,szBuffer,lstrlen(szBuffer),&dwDummy,NULL)

#define WINPRINTBOX(fmtstr,val) wsprintf(szBuffer,fmtstr,val); \
	                         MessageBox(NULL,szBuffer,"Info",MB_ICONINFORMATION)



// Data galore..

int __stdcall hub(int,int,void*,void*);

LRESULT CALLBACK page1_dlgproc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK page2_dlgproc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK page3_dlgproc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK page4_dlgproc(HWND,UINT,WPARAM,LPARAM);

unsigned int	arm9PluginVersion,mmuPluginVersion,gpuPluginVersion,inpPluginVersion,
				guiVersion=16;


HWND			hMain,hPropsheet,hMainChk,hSubChk,hMainScr,hSubScr,hStatus,hPalw,hDbgw,hMemw;
HWND			hScrollbar1,hScrollbar2,hComboMem;
HDC				paldc,dbgdc,memdc,disdc,iodc,twdc,mapdc,oamdc,texdc;
HFONT			font;
HANDLE			hOut;
HINSTANCE		hInst=NULL,hCPU,hCPUsub,hMMU,hGPU,hINP;
HACCEL			haccel;
PAINTSTRUCT		ps;
MSG				msg;
UINT			defaultFontID;

unsigned int	*arm9_regs,*arm7_regs;
char			**pageTable;
char			vPath[256],*szPath,currDir[256];
int				mirrorIPC = 1;
NDSFileHeader	hdr;
MSPAL			mspal;

char			dbgMessages[32][64];
int				dbgMsgCount=0;
int				dbgMsgPos=0,memVPos=0x00800000; //,disVPos=0x02004000>>2;
SCROLLINFO		si,si2,si3,si4;
CScrollBar		memviewScroll,disasmScroll,debugScroll;
COLORREF		colors[8];
unsigned int	memview_lut[13] = {0x00000000,0x00800000,0x02000000,0x02004000,
                                   0x04000000,0x04001000,0x05000000,0x05000400,
								   0x06000000,0x06200000,
					  		       0x06800000,0x07000000,0x08000000};
palette_dib		*pdib;
int				palUpdateMode=1;

DLGPROC			PageDlgProc[4] = {(DLGPROC)page1_dlgproc,(DLGPROC)page2_dlgproc,
							   	(DLGPROC)page3_dlgproc,(DLGPROC)page4_dlgproc,};
CMenu			*menu;
OPENFILENAME	ofName;
window			windows[NUM_WINDOWS];
RECT			rect2;

CEventQueue		*eq;

LARGE_INTEGER	perfCnt1,perfCnt2,perfFreq;

DWORD			dwDummy,dwTimerOf;

char			szBuffer[512],szFnBuffer[400],szBuffer3[256];
char			szFileNameOnly[400];

touchpad		touch;

char			szPropsheetCaption[5][16] = {"CPU         ","Memory      ",
						                     "Video       ","Audio       ",
						    			     "Input       "};
int				propSheetButtons[] = {IDOK, IDCANCEL, 0x3021, IDHELP};

cpu_init_callback cpu_init;
cpu_reset_callback cpu_reset;
cpu_get_callback cpu_get;
cpu_set_callback cpu_set;
cpu_execute_until_callback cpu_execute_until;

// For ARM7
cpu_init_callback cpu_sub_init;
cpu_reset_callback cpu_sub_reset;
cpu_get_callback cpu_sub_get;
cpu_set_callback cpu_sub_set;
cpu_execute_until_callback cpu_sub_execute_until;

mmu_init_callback mmu_init;
mmu_reset_callback mmu_reset;
mmu_get_callback mmu_get;
mmu_set_callback mmu_set;
mmu_close_callback mmu_close;
mmu_read_word_callback mmu_read_word;
mmu_read_dword_callback mmu_read_dword;
mmu_write_byte_callback mmu_write_byte;
mmu_write_word_callback mmu_write_word;
mmu_write_dword_callback mmu_write_dword;

// For ARM7
mmu_read_word_callback mmu_sub_read_word;
mmu_read_dword_callback mmu_sub_read_dword;
mmu_write_byte_callback mmu_sub_write_byte;
mmu_write_word_callback mmu_sub_write_word;
mmu_write_dword_callback mmu_sub_write_dword;

gpu_init_callback	gpu_init;
gpu_reset_callback	gpu_reset;
gpu_get_callback	gpu_get;
gpu_set_callback	gpu_set;
gpu_hblank_callback gpu_hblank;
gpu_advance_line_callback gpu_advance_line;
gpu_close_callback	gpu_close;

mmu_init_callback	inp_init;
mmu_reset_callback	inp_reset;
mmu_get_callback	inp_get;
mmu_set_callback	inp_set;
mmu_close_callback	inp_close;

int				keys[256];
int				renderer=0;
int				fpsLimit=1,frameskip=0;
bool			run,quit,romLoaded;
float			cpuEmuSpeed;
char			*cart,*cartSub;
UINT			speed,cycles,samples,frames,visCycles,totCycles,romSize,romSizeSub;
int				blockDMA=0;

SYSTEMTIME		systime;
int				ipcLoc=0,ipcFormat=1;
bool			openCon;
unsigned char	theme = 6;
int				tsCalibX1,tsCalibY1,tsCalibX2,tsCalibY2;
char			iniFn[256];
unsigned short	tileData[64],objPlainData[64*64],objFinalData[128*128];
palette_dib		tile,objPlain,objFinal;




bool			pendingPause,pendingScreenshot;
int				bmpFrameSelection;
int				screenshots=0;
loaded_bitmap	bmp_framebuf;
char			szScrFn[256];


#define UYVY 0x59565955






void screenshot()
{
	framebuffer = (char*)gpu_get(bmpFrameSelection);
	if (framebuffer)
	{
		wsprintf(szScrFn,"%s\\dualis%02d.bmp",szPath,screenshots);
		screenshots++;
		bmp_framebuf.bpp = 24;
		bmp_framebuf.lpbits = framebuffer;
		bmp_framebuf.xdim = 256;
		bmp_framebuf.ydim = (bmpFrameSelection==GPU_FRAMEBUFFER_BGR24) ? 384 : 192;
		bmp_save(szScrFn,&bmp_framebuf,&bmp_framebuf);
	}
}



void emulate()
{
	LONGLONG t1;
	UINT c1;
	event e;
	int i;

	// Send message to the debug console
	hub(TELL,ZOMBIE_DEBUG_MSG,"Beginning emulation",0);

	SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Running");
	GetLocalTime(&systime);

	while (run)
	{
		// Pull the next event off the queue
		eq->dequeue(&e);

		// Execute the number of cycles up till the next event, and measure
		// the time it took to do it.
		QueryPerformanceCounter(&perfCnt1);
	//CreateThread(0, 4096, cpu_sub_execute_until, 0, 0, &tSubID);
		c1 = cpu_execute_until(e.timestamp);
	//CreateThread(0, 4096, cpu_execute_until, 0, 0, &tID);
	
		QueryPerformanceCounter(&perfCnt2);

		// Update the current execution speed measure
		t1 = perfCnt2.QuadPart - perfCnt1.QuadPart;
		if (t1>1)
		{
			cpuEmuSpeed += (float)(c1 - cycles) / (float)t1;
			samples++;
		}

		// Check the kind of event that occured
		switch (e.data&0xFF)
		{
			case EV_HBLANK_START:
				cycles = c1;
				gpu_hblank();
				break;

			case EV_HBLANK_END:
				gpu_advance_line();
				cycles = c1;

				// Process window messages
				while(PeekMessage(&msg,NULL,0,0,1))
				{
					if (!TranslateAccelerator(
							hMain,      // handle to receiving window
							haccel,     // handle to active accelerator table
							&msg))      // message data
					{
						TranslateMessage(&msg);
						DispatchMessage(&msg);
					}
				}

				e.timestamp = cycles+visCycles; e.data = EV_HBLANK_START;
				eq->enqueue(&e);
				e.timestamp = cycles+totCycles; e.data = EV_HBLANK_END;
				eq->enqueue(&e);
				break;

			case EV_TIMER_OVERFLOW:
				mmu_set(MMU_TIMER_OVERFLOW,e.data&0xFF0000,0);
				cycles = c1;
				break;
		}
	}
}



void reset_machine(bool hard)
{
	float f;
	int totlines,linesize,hbipixels,scale,i;
	event e;
	static char usrname[]="G.W. Bush";
	static char usrmsg[]="Dubya haqd your ds!";

	// Reset MMU plugin
	if (!mmu_reset())
	{
		hub(TELL,ZOMBIE_DEBUG_MSG,"mmu_reset failed",0);
		WINERROR("mmu_reset failed.");
		gpu_close();
		mmu_close();
		ExitProcess(0);
	}

	// Reset input plugin
	inp_reset();

	// Personal info ////////////////////////////////
	mmu_write_byte(0x23FFC82,theme);
	mmu_write_byte(0x23FFC83,7);
	mmu_write_byte(0x23FFC84,6);

	for (i=0; i<strlen(usrname); i++)
	{
		mmu_write_byte(0x23FFC86+i+i+1,0);
		mmu_write_byte(0x23FFC86+i+i,usrname[i]);
	}

	for (i=0; i<strlen(usrmsg); i++)
	{
		mmu_write_byte(0x23FFC9C+i+i+1,0);
		mmu_write_byte(0x23FFC9C+i+i,usrmsg[i]);
	}

	mmu_write_byte(0x23FFCD0,strlen(usrmsg));
	mmu_write_byte(0x23FFCD1,0);
	mmu_write_byte(0x23FFC9A,strlen(usrname));
	mmu_write_byte(0x23FFC9B,0);

	mmu_write_word(0x23FFCD8,tsCalibX1);
	mmu_write_word(0x23FFCDA,tsCalibY1);
	mmu_write_byte(0x23FFCDC,0x20);
	mmu_write_byte(0x23FFCDD,0x20);

	mmu_write_word(0x23FFCDE,tsCalibX2);
	mmu_write_word(0x23FFCE0,tsCalibY2);
	mmu_write_byte(0x23FFCE2,256-0x20);
	mmu_write_byte(0x23FFCE3,192-0x20);

	mmu_set(PLUGIN_SETTING, 11, mirrorIPC);
	/////////////////////////////////////////////////

	// Reset CPU plugin
	cpu_reset();
	//cpu_sub_reset();

	// Reset GPU plugin
	gpu_reset();

	//apu_reset,{})

	// Copy the ARM9 binary to RAM
	pageTable = (char**)mmu_get(MMU_PAGE_TABLE);
	memcpy(pageTable[hdr.uARM9CopyTo>>20]+(hdr.uARM9CopyTo&0xFFFFF), cart, romSize);

	wsprintf(szBuffer,"Copying %08X bytes to %08X\n",romSize,hdr.uARM9CopyTo);
	WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

	//wsprintf(szBuffer,"[%08X] = %08X\n",0,*(int*)(pageTable[0x20]+0x199220));
	//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);


	speed = cpu_get(CPU_SPEED);
	scale = cpu_get(CPU_CYCLE_SCALING);
	cpu_set(CPU_CYCLE_COUNT,0,0);
	cycles = cpu_get(CPU_CYCLE_COUNT);

	// Reset the ARM9 program counter
	hub(TELL,CPU_REG_PC,(void*)hdr.uARM9ExecuteFrom,0);

	// Get a pointer to the ARM9 pagetable
	pageTable = (char**)mmu_get(MMU_PAGE_TABLE);

	// Scanlines per frame
	totlines = 263;

	// Pixels during hblank
	hbipixels = 99;

	// Pixels per scanline
	linesize = 355;

	// Cycles per scanline (visible part)
	visCycles = 1536 * 2;

	// Cycles per scanline (total)
	totCycles = 2130 * 2;

	// Flush the event queue
	eq->flush();

	// Initialize the queue
	if (!run)
	{
		e.timestamp = cycles+visCycles; e.data = EV_HBLANK_START;
		eq->enqueue(&e);
		e.timestamp = cycles+totCycles; e.data = EV_HBLANK_END;
		eq->enqueue(&e);
	}

	disasmScroll.pos = 0x02004000>>2;

	pendingPause = pendingScreenshot = false;
}




// Returns the directory that the program is being executed from
const char *get_path()
{
	if (*vPath) return vPath;
	ZeroMemory(vPath, sizeof(vPath));
	GetModuleFileName(hInst, vPath, sizeof(vPath));
	char *p = vPath + lstrlen(vPath);
	while (p >= vPath && *p != '\\') p--;
	if (++p >= vPath) *p = 0;
	return vPath;
}



// Force a desired window size and/or position
void force_window_size(HWND hWnd,int x,int y,int width,int height)
{
	RECT rect3;

	GetWindowRect(hWnd,&rect3);
	rect3.right -= rect3.left;
	rect3.bottom -= rect3.top;

	GetClientRect(hWnd,&rect2);
	if ((rect2.right!=width)||(rect2.bottom!=height))
	{
		SetWindowPos(hWnd, NULL, x, y,
			         rect3.right+(width-rect2.right),
					 rect3.bottom+(height-rect2.bottom),
					 SWP_NOZORDER);
	} else
	{
		SetWindowPos(hWnd, NULL, x, y,
			         0,0,
					 SWP_NOSIZE|SWP_NOZORDER);
	}
}



void init()
{
	if (openCon)
	{
		AllocConsole();
		hOut = GetStdHandle(STD_OUTPUT_HANDLE);
	}

	// Get the performance counter update frequency
	QueryPerformanceFrequency(&perfFreq);

	// Load plugins
	wsprintf(szBuffer,"%s\\arm9.dll",szPath);
	if ((hCPU = LoadLibrary(szBuffer)) == NULL)
	{
		WINERROR("LoadLibrary failed.");
		ExitProcess(0);
	}

	wsprintf(szBuffer,"%s\\arm7.dll",szPath);
	if ((hCPUsub = LoadLibrary(szBuffer)) == NULL)
	{
		//WINERROR("LoadLibrary failed.");
		//ExitProcess(0);
	}

	wsprintf(szBuffer,"%s\\dsmmu.dll",szPath);
	if ((hMMU = LoadLibrary(szBuffer)) == NULL)
	{
		WINERROR("LoadLibrary failed.");
		ExitProcess(0);
	}

	wsprintf(szBuffer,"%s\\dsgpu.dll",szPath);
	if ((hGPU = LoadLibrary(szBuffer)) == NULL)
	{
		WINERROR("LoadLibrary failed.");
		ExitProcess(0);
	}

	wsprintf(szBuffer,"%s\\input.dll",szPath);
	if ((hINP = LoadLibrary(szBuffer)) == NULL)
	{
		WINERROR("LoadLibrary failed.");
		ExitProcess(0);
	}

	cpu_init = (cpu_init_callback)GetProcAddress(hCPU,"cpu_init");
	cpu_reset = (cpu_reset_callback)GetProcAddress(hCPU,"cpu_reset");
	cpu_get = (cpu_get_callback)GetProcAddress(hCPU,"cpu_get");
	cpu_set = (cpu_set_callback)GetProcAddress(hCPU,"cpu_set");
	cpu_execute_until = (cpu_execute_until_callback)GetProcAddress(hCPU,"cpu_execute_until");

	cpu_sub_init = (cpu_init_callback)GetProcAddress(hCPUsub,"cpu_init");
	cpu_sub_reset = (cpu_reset_callback)GetProcAddress(hCPUsub,"cpu_reset");
	cpu_sub_get = (cpu_get_callback)GetProcAddress(hCPUsub,"cpu_get");
	cpu_sub_set = (cpu_set_callback)GetProcAddress(hCPUsub,"cpu_set");
	cpu_sub_execute_until = (cpu_execute_until_callback)GetProcAddress(hCPUsub,"cpu_execute_until");

	cpu_sub_init = (cpu_init_callback)GetProcAddress(hCPUsub,"cpu_init");
	cpu_sub_reset = (cpu_reset_callback)GetProcAddress(hCPUsub,"cpu_reset");
	cpu_sub_get = (cpu_get_callback)GetProcAddress(hCPUsub,"cpu_get");
	cpu_sub_set = (cpu_set_callback)GetProcAddress(hCPUsub,"cpu_set");
	cpu_sub_execute_until = (cpu_execute_until_callback)GetProcAddress(hCPUsub,"cpu_execute_until");

	mmu_init = (mmu_init_callback)GetProcAddress(hMMU,"mmu_init");
	mmu_reset = (mmu_reset_callback)GetProcAddress(hMMU,"mmu_reset");
	mmu_get = (mmu_get_callback)GetProcAddress(hMMU,"mmu_get");
	mmu_set = (mmu_set_callback)GetProcAddress(hMMU,"mmu_set");
	mmu_close = (mmu_close_callback)GetProcAddress(hMMU,"mmu_close");
	mmu_read_word = (mmu_read_word_callback)GetProcAddress(hMMU,"mmu_read_word");
	mmu_read_dword = (mmu_read_dword_callback)GetProcAddress(hMMU,"mmu_read_dword");
	mmu_write_byte = (mmu_write_byte_callback)GetProcAddress(hMMU,"mmu_write_byte");
	mmu_write_word = (mmu_write_word_callback)GetProcAddress(hMMU,"mmu_write_word");
	mmu_write_dword = (mmu_write_dword_callback)GetProcAddress(hMMU,"mmu_write_dword");

	gpu_init = (gpu_init_callback)GetProcAddress(hGPU,"gpu_init");
	gpu_reset = (gpu_reset_callback)GetProcAddress(hGPU,"gpu_reset");
	gpu_get = (gpu_get_callback)GetProcAddress(hGPU,"gpu_get");
	gpu_set = (gpu_set_callback)GetProcAddress(hGPU,"gpu_set");
	gpu_hblank = (gpu_hblank_callback)GetProcAddress(hGPU,"gpu_hblank");
	gpu_advance_line = (gpu_advance_line_callback)GetProcAddress(hGPU,"gpu_advance_line");
	gpu_close = (gpu_close_callback)GetProcAddress(hGPU,"gpu_close");


	inp_init = (mmu_init_callback)GetProcAddress(hINP,"inp_init");
	inp_reset = (mmu_reset_callback)GetProcAddress(hINP,"inp_reset");
	inp_get = (mmu_get_callback)GetProcAddress(hINP,"inp_get");
	inp_set = (mmu_set_callback)GetProcAddress(hINP,"inp_set");
	inp_close = (mmu_close_callback)GetProcAddress(hINP,"inp_close");

	if (cpu_init((zombie_callback)hub)==0)
	{
		WINERROR("cpu_init failed.");
		ExitProcess(0);
	}
	/*if (cpu_sub_init((zombie_callback)hub)==0)
	{
		WINERROR("cpu_sub_init failed.");
		ExitProcess(0);
	}*/

	if (mmu_init((zombie_callback)hub)==0)
	{
		WINERROR("mmu_init failed.");
		ExitProcess(0);
	}

	mmu_set(PLUGIN_SETTING, 20, ipcFormat);

	if (gpu_init((zombie_callback)hub)==0)
	{
		WINERROR("gpu_init failed.");
		ExitProcess(0);
	}

	if (gpu_get(GPU_RENDERER_OK)==0)
	{
		gpu_close();
		mmu_close();
		MessageBox(NULL,"Failed to find a suitable rendering mode.","Error",MB_ICONERROR);
		ExitProcess(0);
	}

	gpu_set(PLUGIN_SETTING, 0, frameskip);
	gpu_set(PLUGIN_SETTING, 1, fpsLimit);
	gpu_set(PLUGIN_SETTING, 20, renderer);

	if (inp_init((zombie_callback)hub)==0)
	{
		gpu_close();
		mmu_close();
		WINERROR("inp_init failed.");
		ExitProcess(0);
	}

	pageTable = (char**)mmu_get(MMU_PAGE_TABLE);

	romLoaded = false;

	memviewScroll.pos = 0x00800000;
	disasmScroll.pos = 0x02004000>>2;

	arm9PluginVersion = cpu_get(PLUGIN_VERSION);
	mmuPluginVersion = mmu_get(PLUGIN_VERSION);
	gpuPluginVersion = gpu_get(PLUGIN_VERSION);
	inpPluginVersion = inp_get(PLUGIN_VERSION);

	pendingPause = pendingScreenshot = false;
}



void __stdcall apu_write_stub(unsigned char c1,unsigned char c2)
{
}



int __stdcall hub(int direction,int topic,void *param1,void *param2)
{
	event e;
	int i;


	switch (direction)
	{
		case ASK:

			switch(topic)
			{
				case CPU_IRQ_CALLBACK:
				case CPU_CYCLE_COUNT:
				case CPU_REG:
				case CPU_REG_PC:
				case CPU_DMA_CALLBACK:
					return cpu_get(topic);

				case MMU_PAGE_TABLE:
					//hub(TELL,ZOMBIE_DEBUG_MSG,"Returning page table",0);
				case MMU_DTCM:
				case MMU_ITCM:
				case MMU_IRQ_OK:
				case MMU_READ_BYTE_CALLBACK:
				case MMU_GET_CALLBACK:
				case MMU_READ_WORD_CALLBACK:
				case MMU_READ_WORD_CALLBACKS:
				case MMU_READ_DWORD_CALLBACK:
				case MMU_READ_DWORD_CALLBACKS:
				case MMU_WRITE_BYTE_CALLBACK:
				case MMU_WRITE_WORD_CALLBACK:
				case MMU_WRITE_WORD_CALLBACKS:
				case MMU_WRITE_DWORD_CALLBACK:
				case MMU_WRITE_DWORD_CALLBACKS:
				case MMU_TRANSLATE_ADDRESS_CALLBACK:
				case MMU_IRQ_CALLBACK:
				case MMU_VRAM_BANKS:
					return mmu_get(topic|(((int)param1&1)<<16));

				case GPU_MEMORY:
					//hub(TELL,ZOMBIE_DEBUG_MSG,"Asking for GPU memory",0);
					return gpu_get(topic);
				case GPU_SET_CALLBACK:
					return (int)gpu_set;
				case GPU_GET_CALLBACK:
					return (int)gpu_get;

				case APU_WRITE_CALLBACK:
					return (int)apu_write_stub;

				case ZOMBIE_WINDOW_HANDLE:
					return (int)windows[(int)param1&0xFF].hwnd;

				case ZOMBIE_ROM_BASE:
					return (int)cart;
				case ZOMBIE_ROM_SIZE:
					return romSize;
				case ZOMBIE_KEYSTATE:
					return keys[(int)param1 & 0xFF];

				case TOUCHPAD_DATA:
					return (int)&touch;

			}
			//wsprintf(szBuffer,"Return default value (0) for message 0x%X",topic);
			//hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
			return 0;

		case TELL:
			switch (topic)
			{
				case ZOMBIE_EVENT:
					e.data = (UINT)param1;
					e.timestamp = (UINT)param2;
					eq->enqueue(&e);
					break;

				case MMU_IRQ:
				case MMU_IRQ_OVER:
					mmu_set(topic,(unsigned int)param1,(int)param2);
					break;
				case MMU_READ_WORD_CALLBACKS:
					cpu_set(topic,(unsigned int)param1,(int)param2);
					break;

				case INPUT_KEYDOWN:
					mmu_set(ZOMBIE_KEYSTATE,(unsigned int)param1,1);
					break;
				case INPUT_KEYUP:
					mmu_set(ZOMBIE_KEYSTATE,(unsigned int)param1,0);
					break;

				case ZOMBIE_DEBUG_MSG:
					// string pointer in param1
					if (dbgMsgCount==32)
					{
						for (i=0; i<31; i++)
							strcpy(dbgMessages[i],dbgMessages[i+1]);
						strncpy(dbgMessages[31],(const char*)param1,48);
					} else
						//strcpy(dbgMessages[dbgMsgCount++],(const char*)param1);
						strncpy(dbgMessages[dbgMsgCount++],(const char*)param1,48);

					si.nPos = dbgMsgPos;
			        si.nMax   = dbgMsgCount-1;
			        SetScrollInfo(hScrollbar1, SB_CTL, &si, TRUE);

					if (windows[4].active)
					{
						rect2.left = 8;
						rect2.top = 32;
						rect2.right = 250;
						rect2.bottom = -1;
						InvalidateRect(windows[4].hwnd,NULL,TRUE);
					}
					break;

				case MMU_TCM_REMAP:
					mmu_set(topic,(unsigned int)param1,(int)param2);
					break;

				case ZOMBIE_HALT:
					run = false;
					break;

				case CPU_SPEED:
					speed = (UINT)param1;
					break;

				case CPU_CYCLE_PTR:
					mmu_set(topic,(unsigned int)param1,(unsigned int)param2);
					//apu_set(topic,param1,param2)
					break;

				case CPU_WAKE_UP:
					cpu_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

				case CPU_IO_HANDLER:
					cpu_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

				case CPU_REG_PC:
					//MessageBox(NULL,"CPU_REG_PC","Message",MB_OK);
					cpu_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

				case GPU_FRAME_COMPLETED:
					frames++;
					if (windows[3].active && run && (palUpdateMode==4))
						InvalidateRect(windows[3].hwnd,NULL,FALSE);
					if (pendingPause)
					{
						run = false;
						pendingPause = false;
					}
					if (pendingScreenshot)
					{
						pendingScreenshot = false;
						screenshot();

					}
					//apu_mix();
					avi_record_frame();
					break;

				case GPU_VBLANK_ACTION:
				case GPU_HBLANK_ACTION:
					gpu_set(topic,(unsigned int)param1,(unsigned int)param2);
					break;

			}
			return 0;
	}

	//wsprintf(szBuffer,"Bad direction (%X, %X, %X, %X)",direction,topic,param1,param2);
	//hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
	return 0;
}


char *load_nds(char *fname, char *buffer, bool fromFile) {
	HANDLE hFile;
	DWORD dwBytesRead;

	if (fromFile) {
		hFile = CreateFile(fname, GENERIC_READ, 0, NULL, OPEN_EXISTING,
		                   FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,
			               NULL);
		if (hFile == INVALID_HANDLE_VALUE)
			return 0;

		ReadFile(hFile,&hdr,sizeof(NDSFileHeader),&dwBytesRead,NULL);
	} else {
		memcpy(&hdr,buffer,sizeof(NDSFileHeader));
	}

	if (hdr.uARM9Size > (64*1024*1024))	{
		wsprintf(szBuffer,"%s will not be loaded. Bad header or invalid file format (ARM9Size = %d)",
			hdr.uARM9Size);
		MessageBox(NULL,szBuffer,"Error",MB_ICONERROR);
		if (fromFile) CloseHandle(hFile);
		return NULL;
	}

	if (hdr.uARM9Size > (32*1024*1024))	{
		wsprintf(szBuffer,"Suspicious ARM9 size: %d bytes.\nAre you sure you wish to proceed?",
				hdr.uARM9Size);
		if (MessageBox(NULL,szBuffer,"Question",MB_YESNO|MB_ICONQUESTION)!=IDYES)
		{
			if (fromFile) CloseHandle(hFile);
			return NULL;
		}
	}

	if (hdr.uARM7Size > (64*1024*1024))	{
		wsprintf(szBuffer,"%s will not be loaded. Bad header or invalid file format (ARM7Size = %d)",
			hdr.uARM7Size);
		MessageBox(NULL,szBuffer,"Error",MB_ICONERROR);
		if (fromFile) CloseHandle(hFile);
		return NULL;
	}

	if (hdr.uARM7Size > (32*1024*1024))	{
		wsprintf(szBuffer,"Suspicious ARM7 size: %d bytes.\nAre you sure you wish to proceed?",
				hdr.uARM7Size);
		if (MessageBox(NULL,szBuffer,"Question",MB_YESNO|MB_ICONQUESTION)!=IDYES)
		{
			if (fromFile) CloseHandle(hFile);
			return NULL;
		}
	}

	/*wsprintf(szBuffer,"arm9 loc: %08X\narm9 exec: %08X\narm9 copyto: %08X\narm9 size: %08X\n",
				hdr.uARM9Source,hdr.uARM9ExecuteFrom,hdr.uARM9CopyTo,hdr.uARM9Size);
	WriteConsole(hOut,szBuffer,strlen(szBuffer),(LPDWORD)&dwDummy,NULL);*/

	romSize = hdr.uARM9Size;
	romSizeSub = hdr.uARM7Size;

	cart = (char*)LocalAlloc(LPTR,romSize+romSizeSub);
	memset(cart,0,romSize+romSizeSub);
	cartSub = cart+romSize;

	if (fromFile) {
		SetFilePointer(hFile,hdr.uARM9Source,NULL,FILE_BEGIN);
		ReadFile(hFile,cart,romSize,&dwBytesRead,NULL);
		if (dwBytesRead != romSize)	{
			LocalFree((HLOCAL)cart);
			return 0;
		}
		SetFilePointer(hFile,hdr.uARM7Source,NULL,FILE_BEGIN);
		ReadFile(hFile,cartSub,romSizeSub,&dwBytesRead,NULL);
		if (dwBytesRead != romSizeSub) {
			LocalFree((HLOCAL)cart);
			return 0;
		}
		CloseHandle(hFile);
	} else {
		memcpy(cart,buffer+hdr.uARM9Source,romSize);
		memcpy(cartSub,buffer+hdr.uARM7Source,romSizeSub);
	}

	EnableMenuItem(menu->popups[0]->hMenu,IDM_ROM_INFO,MF_ENABLED);

	return cart;
}



char *load_arm9_bin(char *fname) {
	HANDLE hFile;
	DWORD dwBytesRead;
	char *p;
	int l;

	hFile = CreateFile(fname, GENERIC_READ, 0, NULL, OPEN_EXISTING,
                       FILE_ATTRIBUTE_NORMAL|FILE_FLAG_SEQUENTIAL_SCAN,
                       NULL);
	if (hFile == INVALID_HANDLE_VALUE)
		return 0;

	romSize = GetFileSize(hFile,NULL);
	romSizeSub = 0;
	cart = (char*)LocalAlloc(LPTR,romSize);
	cartSub = NULL;
	memset(cart,0,romSize);
	ReadFile(hFile,cart,romSize,&dwBytesRead,NULL);
	if (dwBytesRead != romSize)	{
		LocalFree((HLOCAL)cart);
		return 0;
	}
	CloseHandle(hFile);
	hdr.uARM9CopyTo = 0x2004000;
	hdr.uARM9ExecuteFrom = 0x2004000;
	return cart;
}



char *load_rom(char *fname) {
	HANDLE hFile;
	DWORD dwBytesRead;
	HZIP hz;
	ZIPENTRY ze;
	char *p,*cart;
	int i,l;
	char *unzipBuffer;

	EnableMenuItem(menu->popups[0]->hMenu,IDM_ROM_INFO,MF_GRAYED);

	l = lstrlen(fname);
	if (l>3)
	{
		p = &fname[l-3];
		if (strcmp(p,"zip") == 0) {
			hz = OpenZip(fname,"");
			if ((int)hz == 0) {
				return 0;
			}
			// Try at most 256 files
			for (i=0; i<256; i++) {
				if (GetZipItem(hz,i,&ze)) {
					CloseZip(hz);
					return 0;
				}
				if (strlen(ze.name)>4) {
					if (stricmp(&ze.name[strlen(ze.name)-4],".nds") == 0) {
						if (ze.unc_size == -1) {
							CloseZip(hz);
							return 0;
						}
						if ((unzipBuffer = (char*)LocalAlloc(LPTR,ze.unc_size)) == NULL) {
							CloseZip(hz);
							return 0;
						}
						UnzipItem(hz,i,unzipBuffer,ze.unc_size);
						cart = load_nds(NULL,unzipBuffer,false);
						CloseZip(hz);
						LocalFree(unzipBuffer);
						return cart;
					}
				}
			}
			return 0;

		} else if (strcmp(p,"nds")==0)
			return load_nds(fname,NULL,true);
	}
	return load_arm9_bin(fname);
}




int get_openfilename(char *szBuf, char *szTitle, char *szFilter)
{
   ofName.lStructSize = sizeof(OPENFILENAME);
   ofName.hwndOwner = hMain;
   ofName.lpstrFilter = szFilter;
   ofName.nFilterIndex = 1;
   ofName.lpstrFile = szBuf;
   ofName.lpstrFileTitle = szFileNameOnly;
   ofName.nMaxFile = 399;
   ofName.nMaxFileTitle = 200;
   ofName.lpstrInitialDir = NULL;
   ofName.lpstrTitle = szTitle;
   ofName.Flags = OFN_EXPLORER | OFN_OVERWRITEPROMPT;
   return (GetOpenFileName(&ofName));
}


int get_savefilename(char *szBuf, char *szTitle, char *szFilter)
{
   ofName.lStructSize = sizeof(OPENFILENAME);
   ofName.hwndOwner = hMain;
   ofName.lpstrFilter = szFilter;
   ofName.nFilterIndex = 1;
   ofName.lpstrFile = szBuf;
   ofName.lpstrFileTitle = szFileNameOnly;
   ofName.nMaxFile = 399;
   ofName.nMaxFileTitle = 200;
   ofName.lpstrInitialDir = NULL;
   ofName.lpstrTitle = szTitle;
   ofName.Flags = OFN_EXPLORER | OFN_OVERWRITEPROMPT;
   return (GetSaveFileName(&ofName));
}



HWND create_window(char *pszTitle,char *pszClass,char *pszIcon,char *pszCursor,int nColor,int xdim,int ydim,WNDPROC msgHandler)
{
	HWND hWindow;
	HICON hIcon;
	HCURSOR hCursor;
	WNDCLASSEX wc;
	ATOM aClass;

	if (pszIcon != NULL)
		hIcon = LoadIcon(hInst,pszIcon);
	else
		hIcon = LoadIcon(hInst,MAKEINTRESOURCE(IDI_ICON1)); //IDI_APPLICATION);

	if (pszCursor != NULL)
		hCursor = LoadIcon(hInst,pszCursor);
	else
		hCursor = LoadCursor(NULL,IDC_ARROW);

	wc.cbSize = sizeof(wc);
	wc.style = CS_OWNDC | CS_HREDRAW | CS_VREDRAW;
	wc.hIcon = wc.hIconSm = hIcon;
	wc.cbClsExtra = wc.cbWndExtra = 16;
	wc.hCursor = hCursor;
	wc.hbrBackground = (HBRUSH)MAKEINTRESOURCE(nColor+1);
	wc.hInstance = hInst;
	wc.lpfnWndProc = msgHandler;
	wc.lpszClassName = pszClass;
	wc.lpszMenuName = NULL;

	if ((aClass=RegisterClassExA(&wc))==0)
	{
		WINERROR("RegisterClassEx failed.");
		ExitProcess(0);
	}

	if (strcmp(pszClass,"SbScrClass")==0)
	{
		rect2.top = 0;
		rect2.left = 0;
		rect2.right = 255;
		rect2.bottom = 383;
		AdjustWindowRect(&rect2,WS_POPUP|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX,0);
		hWindow = CreateWindowEx(NULL,(LPSTR)aClass,pszTitle,WS_POPUP|WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX,
			40,40,rect2.right,rect2.bottom,NULL,NULL,hInst,NULL);
	} else
	{
		rect2.right = xdim;
		rect2.bottom = ydim;
		hWindow = CreateWindowEx(NULL,(LPSTR)aClass,pszTitle,WS_CAPTION|WS_BORDER|WS_SYSMENU|WS_MINIMIZEBOX, //(WS_OVERLAPPED|WS_CAPTION|WS_SYSMENU|WS_THICKFRAME|WS_MINIMIZEBOX),
			40,40,rect2.right,rect2.bottom,NULL,NULL,hInst,NULL);
	}


	if (hWindow==NULL)
	{
		WINERROR("CreateWindowEx failed.");
		ExitProcess(0);
	}

	return hWindow;
}







/////////////////////////////////////////////////////////////////////////////////////////


DWORD *lpfnOldWndProc;

LRESULT CALLBACK input_proc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{

	if (hwnd == hMain)
	{
		switch (uMsg)
		{
			case WM_KEYDOWN:

				keys[wParam&0xFF] = 1;
				mmu_set(ZOMBIE_KEYSTATE,wParam&0xFF,1);
				switch (wParam)
				{
					case VK_F5:
						if (romLoaded)
							run = true;
						break;
					/*case VK_F6:
						if (romLoaded)
							run = false;
						break;
					case VK_F7:
						if (romLoaded)
							reset_machine(false);
						break;*/

					case VK_ESCAPE:
						PostMessage(hwnd, WM_CLOSE, wParam, lParam);
						break;

				}
				break;

			case WM_KEYUP:
				keys[wParam&0xFF] = 0;
				mmu_set(ZOMBIE_KEYSTATE,wParam&0xFF,0);
				break;

			//case WM_CLOSE:
			case WM_DESTROY:
				SetWindowLong(hMain, GWL_WNDPROC, (DWORD)lpfnOldWndProc);
				break;
		}
	}

	return CallWindowProc((WNDPROC)lpfnOldWndProc,hwnd,uMsg,wParam,lParam);
}



LRESULT CALLBACK wnd_proc(HWND hwnd,UINT uMsg,WPARAM wParam,LPARAM lParam)
{
	RECT rect;
	HDC dc;
	HWND hdlg,hwndFocus;
	int i,j,k,l;
	DWORD dwTick;
	//palette_dib *pdib;
	pTransferRegion pIPC;

	if (hwnd == hMain)
	{
		switch (uMsg)
		{
			case WM_DROPFILES:
					if (romLoaded)
					{
						run = false;
						//memset(cart,0,romSize);
						LocalFree((HLOCAL)cart);
						romLoaded = false;
					}
					//SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
					DragQueryFile((HDROP)wParam,0,szFnBuffer,256);
					DragFinish((HDROP)wParam);
					cart = load_rom(szFnBuffer);
					if (cart)
					{
						//wsprintf(szBuffer,"Loaded ROM: %s",szFileNameOnly);
						//hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
						romLoaded = true;
						reset_machine(true);
						//SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
						run = true;
					} else
					{
						SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
						run = false;
					}
					break;

			case WM_COMMAND:
				switch (LOWORD(wParam))
				{
					case IDM_LOAD_AND_EXEC:
						if (!get_openfilename(szFnBuffer,"Load ROM","ROM files (*.bin,*.nds,*.zip)\0*.bin;*.nds;*.zip\0"))
						{
							//COMMDLGERROR("OFN failed.");
							break;
						}
						if (romLoaded)
						{
							run = false;
							//memset(cart,0,romSize);
							LocalFree((HLOCAL)cart);
							romLoaded = false;
						}
						SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
						cart = load_rom(szFnBuffer);
						if (cart)
						{
							wsprintf(szBuffer,"Loaded ROM: %s",szFileNameOnly);
							hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
							romLoaded = true;
							reset_machine(true);
							SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
							run = true;
						} else
						{
							SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
							run = false;
						}
						break;

					case IDM_LOAD:
						if (!get_openfilename(szFnBuffer,"Load ROM","ROM files (*.bin,*.nds)\0*.bin;*.nds\0"))
						{
							//COMMDLGERROR("OFN failed.");
							break;
						}
						run = false;
						if (romLoaded)
						{
							LocalFree((HLOCAL)cart);
							romLoaded = false;
						}

						SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)&szFileNameOnly);
						cart = load_rom(szFnBuffer);
						if (cart)
						{
							wsprintf(szBuffer,"Loaded ROM: %s",szFileNameOnly);
							hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
							romLoaded = true;
							reset_machine(true);
						}
						break;

					case IDM_ROM_INFO:
						wsprintf(szBuffer,"Title: %s\n\nARM9 location: \t\t0x%08X\nARM9 execute from: \t0x%08X  \nARM9 copy to: \t\t0x%08X\nARM9 size: \t\t0x%08X\n\nARM7 location: \t\t0x%08X\nARM7 execute from: \t0x%08X\nARM7 copy to: \t\t0x%08X\nARM7 size: \t\t0x%08X\n",
									hdr.szGameTitle,hdr.uARM9Source,hdr.uARM9ExecuteFrom,hdr.uARM9CopyTo,hdr.uARM9Size,
									hdr.uARM7Source,hdr.uARM7ExecuteFrom,hdr.uARM7CopyTo,hdr.uARM7Size);
						MessageBox(NULL,szBuffer,"ROM info",MB_OK);
						break;


					// The reason for postponing the screenshot is to be able to get a
					// finished frame instead of a partially rendered one. If the emulator
					// is in a paused state (run==false) we already have a finished frame,
					// so we can go ahead with taking the screenshot right away.
					//
					case IDM_SCREEN_MAIN:
						hwndFocus = GetFocus();
						if ((!romLoaded) || ((hwndFocus!=hMain) && (hwndFocus!=hSubScr)))
							break;
						bmpFrameSelection = GPU_FRAMEBUFFER_MAIN_BGR24;
						if (run)
							pendingScreenshot = true;
						else
							screenshot();
						break;
					case IDM_SCREEN_SUB:
						hwndFocus = GetFocus();
						if ((!romLoaded) || ((hwndFocus!=hMain) && (hwndFocus!=hSubScr)))
							break;
						bmpFrameSelection = GPU_FRAMEBUFFER_SUB_BGR24;
						if (run)
							pendingScreenshot = true;
						else
							screenshot();
						break;
					case IDM_SCREEN_BOTH:
						hwndFocus = GetFocus();
						if ((!romLoaded) || ((hwndFocus!=hMain) && (hwndFocus!=hSubScr)))
							break;
						bmpFrameSelection = GPU_FRAMEBUFFER_BGR24;
						if (run)
							pendingScreenshot = true;
						else
							screenshot();
						break;

					case IDM_CLOSE:
						if (romLoaded)
							LocalFree((HLOCAL)cart);
						cart = NULL;
						romLoaded = false;
						run = false;
						SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
						break;

					case IDM_EXIT:
						PostMessage(hwnd,WM_CLOSE,wParam,lParam);
						break;

					case IDM_RUN:
						if (romLoaded)
							run = true;
						break;
					case IDM_PAUSE:
						if (romLoaded && run)
							pendingPause = true;
						if (aviIsRecording)
							avi_stop_recording();
							//run = false;
						break;
					case IDM_RESET:
						if (romLoaded)
							reset_machine(false);
						break;

					case IDM_BLOCK_DMA:
						mmu_set(PLUGIN_SETTING,63,blockDMA);
						blockDMA = 1-blockDMA;
						break;

					case IDM_PALETTE:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG10),hwnd,(DLGPROC)DlgProc10);
						windows[3].hwnd = hdlg;
						windows[3].active = true;
						SetWindowPos(hdlg,NULL,rect.left,rect.bottom+20,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;

					case IDM_DBGCON:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG8),hwnd,(DLGPROC)DlgProc8);
						windows[4].hwnd = hdlg;
						windows[4].active = true;
						SetWindowPos(hdlg,NULL,rect.left,rect.bottom+20,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;

					case IDM_MEMORY:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG7),hwnd,(DLGPROC)DlgProc7);
						windows[5].hwnd = hdlg;
						windows[5].active = true;
						SetWindowPos(hdlg,NULL,rect.left+300,rect.bottom+20,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;

					case IDM_DISASM:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG9),hwnd,(DLGPROC)DlgProc9);
						windows[6].hwnd = hdlg;
						windows[6].active = true;
						SetWindowPos(hdlg,NULL,rect.left+300,rect.bottom+20,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;

					case IDM_IOREGS:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG11),hwnd,(DLGPROC)DlgProc11);
						windows[7].hwnd = hdlg;
						windows[7].active = true;
						SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;

					case IDM_TILES:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG12),hwnd,(DLGPROC)DlgProc12);
						windows[8].hwnd = hdlg;
						windows[8].active = true;
						SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;
					case IDM_MAP:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG18),hwnd,(DLGPROC)DlgProc18);
						windows[12].hwnd = hdlg;
						windows[12].active = true;
						SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;
					case IDM_OAM:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG17),hwnd,(DLGPROC)DlgProc17);
						windows[13].hwnd = hdlg;
						windows[13].active = true;
						SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;
					case IDM_TEXTURE:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG19),hwnd,(DLGPROC)DlgProc19);
						windows[14].hwnd = hdlg;
						windows[14].active = true;
						SetWindowPos(hdlg,NULL,rect.left+280,rect.top+80,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;

					case IDM_MOVIE_START:
						avi_start_recording();
						if (aviIsRecording)
							SetWindowText(hMain,"Dualis [Recording]");
						break;
					case IDM_MOVIE_STOP:
						SetWindowText(hMain,"Dualis");
						if (aviIsRecording)
							avi_stop_recording();
						break;
					case IDM_MOVIE_SETUP:
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG16),hwnd,(DLGPROC)DlgProc16);
						windows[11].hwnd = hdlg;
						windows[11].active = true;
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);

						break;

					/*case IDM_BREAKPOINTS:
						GetWindowRect(hwnd,&rect);
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG13),hwnd,(DLGPROC)DlgProc13);
						windows[9].hwnd = hdlg;
						windows[9].active = true;
						SetWindowPos(hdlg,NULL,rect.left+120,rect.top+60,0,0,SWP_NOSIZE|SWP_NOZORDER);						ShowWindow(hdlg,SW_SHOW);
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;*/

					case IDM_ABOUT:
						DialogBoxParam(hInst,
								 MAKEINTRESOURCE(IDD_DIALOG5), hMain,
								 DlgProc5, NULL);

				}
				return 0;

			case WM_ACTIVATE:
				SendMessage(hPropsheet,uMsg,wParam,lParam);
				break;

			case WM_SIZE:
				center_propsheet(lParam);

				if (hStatus != NULL)
				{
					rect.left = 170;//440-100;
					rect.top = 170+180;//440;
					rect.right = -1;
					rect.bottom = -1;
	            	SendMessage(hStatus, SB_SETPARTS, 3, (LPARAM)&rect);
	            	SendMessage(hStatus, WM_SIZE, wParam, lParam);
					//SendMessage(hStatus,SB_SETTEXT,0,(LPARAM)"CPU: 0.0 MHz  GPU: 0 fps");
					//SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");

				}
				/*if (romLoaded)
					SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)szFileNameOnly);
				else
					SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");

				if (run)
					SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Running");
				else
					SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Idle");*/

				break;

			case WM_KEYDOWN:
				//keys[wParam&0xFF] = 1;
				//mmu_set(ZOMBIE_KEYSTATE,wParam&0xFF,1);

				switch (wParam)
				{
					case VK_F5:
						if (romLoaded)
							run = true;
						break;
					case VK_F6:
						if (romLoaded && run)
							pendingPause = true;
							//run = false;
						break;
					case VK_F7:
						if (romLoaded)
							reset_machine(false);
						break;

					case VK_ESCAPE:
						run = false;
						PostMessage(hwnd, WM_CLOSE, wParam, lParam);
						break;

					/*case 'J':
						//start_avi();
						break;
					case 'K':
						//stop_avi();
						MessageBox(NULL,"Stopping AVI output","Message",MB_OK);
						break;
					case 'H':
						hdlg = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG16),hwnd,(DLGPROC)DlgProc16);
						windows[11].hwnd = hdlg;
						windows[11].active = true;
						ShowWindow(hdlg,SW_SHOW);
						SetForegroundWindow(hwnd);
						break;*/

					/*case 'D':
						wsprintf(szBuffer,"PC = %08X\n",cpu_get(CPU_REG_PC));
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
						break;

					case 'G':
						wsprintf(szBuffer,"%04X%04x\n",mmu_read_word(0x4000002),mmu_read_word(0x4000000));
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

						//wsprintf(szBuffer,"%04x %04x\n",mmu_read_word(0x4000050),mmu_read_word(0x4000052));
						//WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

						wsprintf(szBuffer,"%04x %04x %04X %04X\n",mmu_read_word(0x4001008),mmu_read_word(0x400100a),
							mmu_read_word(0x400100c),mmu_read_word(0x400100e));
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);

						for (i=0; i<16; i++)
						{
						wsprintf(szBuffer,"%04X ",mmu_read_word(0x7000400+(i<<1)));
						WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(unsigned long*)&dwDummy,NULL);
						}
						WriteConsole(hOut,"\n",2,(LPDWORD)&i,NULL);*/
				}
				return 0;

			case WM_KEYUP:
				//keys[wParam&0xFF] = 0;
				//mmu_set(ZOMBIE_KEYSTATE,wParam&0xFF,0);
				return 0;

			case WM_TIMER:
				if (wParam == 777)
				{
					dwTick = GetTickCount();
					if (samples)
						cpuEmuSpeed *= (float)perfFreq.QuadPart/(float)(cpu_get(CPU_CYCLE_SCALING)*samples);
					else
						cpuEmuSpeed = 0.0f;
					/*wsprintf(szBuffer,"CPU: %d MHz\tGPU %d fps    ",
							(UINT)(cpuEmuSpeed/((float)(dwTick-dwTimerOf)*1000.0f)),
							(UINT)((float)frames*1000.0f / (float)(dwTick-dwTimerOf)));*/
					wsprintf(szBuffer,"CPU: %d MHz      ",
							(UINT)(cpuEmuSpeed/((float)(dwTick-dwTimerOf)*1000.0f)));
					wsprintf(&szBuffer[16],"GPU: %d fps   ",
							(UINT)((float)frames*1000.0f / (float)(dwTick-dwTimerOf)));
					SendMessage(hStatus,SB_SETTEXT,0,(LPARAM)szBuffer);
					frames = 0;
					cpuEmuSpeed = 0.0f;
					samples = 0;
					dwTimerOf = dwTick;

					/*systime.wSecond++;
					if (systime.wSecond==60)
					{
						systime.wSecond = 0;
						systime.wMinute++;
						if (systime.wMinute==60)
						{
							systime.wMinute = 0;
							systime.wHour++;
							if (systime.wHour==24)
							{
								GetLocalTime(&systime);
							}
						}
					}*/
					GetLocalTime(&systime);

					pIPC = (pTransferRegion)pageTable[0x20];

					// Update IPC time data
					if (false) //ipcLoc)
					{
						mmu_write_dword(0x237F016,((systime.wYear-1744)<<24)|(systime.wMinute<<16)|(systime.wSecond<<8)|(systime.wSecond<<0));
						mmu_write_dword(0x237F01A,(systime.wHour<<24)|(systime.wMonth<<8)|(systime.wDay)|(systime.wSecond<<16));
						//mmu_write_dword(0x237F016,0x04030201);
						//mmu_write_dword(0x237F01A,0x08070605);
					} else
					{
						if (romLoaded)
						{
							/*pIPC->year = 5;
							pIPC->month = systime.wMonth;
							pIPC->day = systime.wDay;
							pIPC->hours = systime.wHour;
							pIPC->minutes = systime.wMinute;
							pIPC->seconds = systime.wSecond;*/

							if (systime.wHour > 11) systime.wHour += 40;

							*(unsigned int*)(pageTable[0x20] + 22) = ((systime.wYear-1744)<<24)|0x070907; //((systime.wYear-1744)<<8) | (systime.wMonth<<16) | (systime.wDay<<24);
							*(unsigned int*)(pageTable[0x20] + 26) = ((systime.wHour)<<24)|(systime.wMonth)|(systime.wDay<<8); //(systime.wMonth);
							*(unsigned int*)(pageTable[0x20] + 30) = (systime.wSecond<<8)|(systime.wMinute);
							*(unsigned int*)(pageTable[0x20] + 34) = 0x08070608;

							if (mirrorIPC)
							{
							*(unsigned int*)(pageTable[0x23] + 0xFF01A) = ((systime.wYear-1744)<<24)|0x070907; //((systime.wYear-1744)<<8) | (systime.wMonth<<16) | (systime.wDay<<24);
							*(unsigned int*)(pageTable[0x23] + 0xFF01E) = ((systime.wHour)<<24)|(systime.wMonth)|(systime.wDay<<8); //(systime.wMonth);
							*(unsigned int*)(pageTable[0x23] + 0xFF022) = (systime.wSecond<<8)|(systime.wMinute);
							*(unsigned int*)(pageTable[0x23] + 0xFF026) = 0x08070608;
							}
							//mmu_write_dword(0x2000016,0x0E|((systime.wYear-1744)<<8)|(systime.wMonth<<16)|(systime.wDay<<24));
						//mmu_write_dword(0x200001A,0x00|(systime.wHour<<8)|(systime.wMinute<<16)|(systime.wSecond<<24));
						//mmu_write_dword(0x2000016,((systime.wYear-1744)<<24)|(systime.wMinute<<16)|(systime.wSecond<<8)|(systime.wSecond<<0));
						//mmu_write_dword(0x200001A,(systime.wHour<<24)|(systime.wMonth<<8)|(systime.wDay)|(systime.wSecond<<16));
						}
					}
					// Prevent timestamp overflows
					if (cycles >= 0x40000000)
					{
						cpu_set(CPU_CYCLE_COUNT,cycles-0x40000000,0);
						cycles = cpu_get(CPU_CYCLE_COUNT);
						for (i=0; i<eq->nItems; i++)
							eq->e[i].timestamp -= 0x40000000;

					}

					if (windows[3].active && run && (palUpdateMode==5))
						InvalidateRect(windows[3].hwnd,NULL,FALSE);
				}
				break;

			case WM_CLOSE:
	  			run = false;
  				quit = true;
  				return 0;

			case WM_DESTROY:
 				KillTimer(hwnd,777);
	 			PostQuitMessage(0);
	  			return 0;
		}


	} else if (hwnd == hSubScr)
	{
		switch (uMsg)
		{
			case WM_KEYDOWN:
				switch (wParam)
				{
					case VK_F5:
						if (romLoaded)
							run = true;
						break;
					case VK_F6:
						if (romLoaded)
							run = false;
						break;
					case VK_F7:
						if (romLoaded)
							reset_machine(false);
						break;
					case VK_ESCAPE:
						run = false;
						PostMessage(hwnd, WM_CLOSE, wParam, lParam);
						break;
				}
				return 0;

			case WM_MOUSEMOVE:
				touch.x = touch.y = touch.z = 0;
				if (GET_Y_LPARAM(lParam)>=192)
				{
					if (wParam & MK_LBUTTON)
					{
						touch.x = GET_X_LPARAM(lParam); //+13;
						touch.y = GET_Y_LPARAM(lParam)+16-192;
						touch.z = -1;
						if (touch.x<0) touch.x = 0; if (touch.x>255) touch.x = 255;
					}
				}
				return 0;
			case WM_LBUTTONDOWN:
				if (GET_Y_LPARAM(lParam)>=192)
				{
					touch.x = GET_X_LPARAM(lParam); //+13;
					touch.y = GET_Y_LPARAM(lParam)+16-192;
					touch.z = -1;
					if (touch.x<0) touch.x = 0; if (touch.x>255) touch.x = 255;
					wsprintf(szBuffer,"x = %d, y = %d | ipc_x = %d, ipc_y = %d\n",
						touch.x,touch.y,touch.x*14,(touch.y*8917)>>9);
					WriteConsole(hOut,szBuffer,lstrlen(szBuffer),(LPDWORD)&i,NULL);
				}
				return 0;

			case WM_LBUTTONUP:
				touch.x = 0;
				touch.y = 0;
				touch.z = 0;
				return 0;

			case WM_CLOSE:
				SendMessage(hMain,WM_CLOSE,0,0);
				return 0;

		}

	}

	return DefWindowProc(hwnd,uMsg,wParam,lParam);
}



void idle()
{
	int i;

	SendMessage(hStatus,SB_SETTEXT,2,(LPARAM)"Idle");
	if (!romLoaded)
		SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");

	while ((!run) && (!quit))
	{
		while(PeekMessage(&msg,NULL,0,0,1))
		{
			if (!TranslateAccelerator(
					hMain,      // handle to receiving window
					haccel,     // handle to active accelerator table
					&msg))      // message data
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}
		}

		// Suspend the process for a short while
		if (!quit)
			Sleep(20);
 	}
}



void shut_down()
{
	delete menu;
	delete eq;

	mmu_close();
	gpu_close();
	inp_close();

	if (aviStreamCreated) //(aviIsRecording)
		avi_stop_recording();

	FreeLibrary(hCPU);
	FreeLibrary(hMMU);
	FreeLibrary(hGPU);
	FreeLibrary(hINP);

	if (romLoaded)
		LocalFree((HLOCAL)cart);

	DestroyWindow(hSubScr);
	DestroyWindow(hStatus);
	DestroyWindow(hMain);
}



COLORREF RGB2BGR(COLORREF cref)
{
	return (cref&0x00FF00)|((cref&0xFF0000)>>16)|((cref&0x0000FF)<<16);
}




int APIENTRY WinMain(HINSTANCE hInstance,HINSTANCE hPrevInstance,LPSTR lpCmdLine,int nCmdShow)
{
	int		i,j,k;
	RECT	rect,rect3;
	HWND	hWnd;
	HMENU	hSysMenu;
	char	*szCommandline;
	static const char delimit = ' ';
	char	*token,*p1,*p2;
	char	*romName = lpCmdLine;

	hInst = hInstance;

	szPath = (char*)get_path();
	GetCurrentDirectory(256,currDir);

	eq = new CEventQueue(128);

	wsprintf(szScrFn,"%s\\dualis.bmp",szPath);
	wsprintf(szAviFn,"c:\\dualis.avi");
	avigen.SetFileName(_T(szAviFn));

	wsprintf(iniFn,"%s\\dualis.ini",szPath);
	fpsLimit = GetPrivateProfileInt("GPU","LimitFPS",1,iniFn);
	frameskip = GetPrivateProfileInt("GPU","Frameskip",0,iniFn);
	renderer = GetPrivateProfileString("GPU","Renderer","OpenGL",szBuffer,32,iniFn);
	if (strcmp("D3D",szBuffer)==0)
		renderer = 1;
	else if (strcmp("GDI",szBuffer)==0)
		renderer = 2;
	else
		renderer = 0;

	ipcFormat = GetPrivateProfileInt("IPC","DefaultIPCVersion",1,iniFn);
	tsCalibX1 = GetPrivateProfileInt("Calibration","x1",0,iniFn);
	tsCalibY1 = GetPrivateProfileInt("Calibration","y1",0,iniFn);
	tsCalibX2 = GetPrivateProfileInt("Calibration","x2",0,iniFn);
	tsCalibY2 = GetPrivateProfileInt("Calibration","y2",0,iniFn);

	openCon = false;

	strcpy(szBuffer,lpCmdLine);
	if (strlen(szBuffer))
	{
		token = strtok(szBuffer,&delimit);
		while (token != NULL)
		{
			if (strcmp("-theme",token)==0)
			{
				token = strtok(NULL,&delimit);
				if (token==NULL) break;
				theme = atoi(token);
			} else if (strcmp("-wincon",token)==0)
			{
				openCon = true;
			}

			token = strtok(NULL,&delimit);
		}
	}

	p1 = strchr(romName,'\"');
	if (p1==NULL) p1 = romName+10000;
	while (strchr(romName,' '))
	{
		p2=strchr(romName,' ')+1;
		if (p2>p1) break;
		romName = p2;
	}


	windows[0].active = false;
	windows[1].active = false;
	windows[2].active = false;
	windows[3].active = false;
	windows[4].active = false;
	windows[5].active = false;
	windows[6].active = false;
	hMain = NULL;

	windows[0].hwnd = hMain = create_window("Dualis","DualisClass",NULL,NULL,COLOR_MENU,440,288+16,(WNDPROC)wnd_proc);
	//windows[1].hwnd = hMainScr = create_window("Main screen","MnScrClass",NULL,NULL,COLOR_MENUTEXT,240+8,160+28,(WNDPROC)wnd_proc);
	//windows[2].hwnd = hSubScr = CreateDialog(hInst,MAKEINTRESOURCE(IDD_DIALOG14),hMain,(DLGPROC)DlgProc14); //create_window("Video output","SbScrClass",NULL,MAKEINTRESOURCE(IDI_ICON2),COLOR_MENUTEXT,240+8,160+28,(WNDPROC)wnd_proc);
	windows[2].hwnd = hSubScr = create_window("Video output","SbScrClass",NULL,MAKEINTRESOURCE(IDI_ICON2),COLOR_MENUTEXT,240+8,160+28,(WNDPROC)wnd_proc);

	windows[0].active = true;
	windows[2].active = true;

	menu = new CMenu;

	defaultFontID = (UINT)GetStockObject(ANSI_VAR_FONT);

	// Create a font
    font = CreateFont(11,0,0,0,
					FW_NORMAL,	// Specify normal font weight
    			    0,			// Italic flag
    			    0,
    			    0,
        	        ANSI_CHARSET,
        	        OUT_OUTLINE_PRECIS,
        	        CLIP_DEFAULT_PRECIS,
        	        ANTIALIASED_QUALITY,
        	        FF_DONTCARE,
        	        "lucida console");

////////////////////////// Set up the debug console window ///////////////////////////////////


	SelectObject(dbgdc, font);
	SetBkColor(dbgdc,GetSysColor(COLOR_MENU));
	SetTextColor(dbgdc,RGB(132,32,32));

    hScrollbar1 = CreateWindowEx(0L,
                   "SCROLLBAR",
                   NULL, // There is no text to display
                   WS_CHILD | WS_VISIBLE | SBS_VERT,
                   296,
                   0,
                   16,
                   172,
                   hDbgw,
                   NULL,
                   hInst,
                   NULL);

        ZeroMemory(&si, sizeof(si));
        si.cbSize = sizeof(si);
        si.fMask  = SIF_RANGE | SIF_PAGE | SIF_POS;
        si.nMin   = 0;
        si.nMax   = 0;
        si.nPage  = 1;
        si.nPos   = 0;
        SetScrollInfo(hScrollbar1, SB_CTL, &si, TRUE);


////////////////////////////////////////////////////////////////////////////////////////////////

	InitCommonControls();

	menu->add_popup("File");
		menu->last->add_item("Load and execute..\tCtrl+R",IDM_LOAD_AND_EXEC,true);
		menu->last->add_item("Load..\tCtrl+L",IDM_LOAD,true);
		menu->last->add_item("ROM info..",IDM_ROM_INFO,false);
		menu->last->add_item("Close",IDM_CLOSE,true);
		menu->last->add_item(0,0,false);
		menu->last->add_popup("Save screenshot");
			menu->last->popup->add_item("Main screen\tCtrl+1",IDM_SCREEN_MAIN,true);
			menu->last->popup->add_item("Sub screen\tCtrl+2",IDM_SCREEN_SUB,true);
			menu->last->popup->add_item("Both screens\tCtrl+3",IDM_SCREEN_BOTH,true);

		menu->last->add_popup("Movie");
			menu->last->popup->add_item("Start recording\t,",IDM_MOVIE_START,true);
			menu->last->popup->add_item("Stop recording\t.",IDM_MOVIE_STOP,true);
			menu->last->popup->add_item("Setup..\tCtrl+V",IDM_MOVIE_SETUP,true);

		menu->last->add_item(0,0,false);
		menu->last->add_item("Exit\tEsc",IDM_EXIT,true);

	menu->add_popup("Emulation");
		menu->last->add_item("Run\tF5",IDM_RUN,true);
		menu->last->add_item("Pause\tF6",IDM_PAUSE,true);
		menu->last->add_item("Reset\tF7",IDM_RESET,true);

	menu->add_popup("View");
		menu->last->add_item("Disassembler..\tCtrl+D",IDM_DISASM,true);
		menu->last->add_item("Memory..\tCtrl+M",IDM_MEMORY,true);
		menu->last->add_item("I/O registers..\tCtrl+I",IDM_IOREGS,true);
		menu->last->add_item("Palette..\tCtrl+P",IDM_PALETTE,true);
		menu->last->add_item("Tiles..\tCtrl+T",IDM_TILES,true);
		menu->last->add_item("Map..\tCtrl+A",IDM_MAP,true);
		menu->last->add_item("OAM..\tCtrl+O",IDM_OAM,true);
		menu->last->add_item("Textures..\tCtrl+X",IDM_TEXTURE,true);
		menu->last->add_item("Debug console..\tCtrl+C",IDM_DBGCON,true);

	menu->add_popup("Help");
		menu->last->add_item("About..",IDM_ABOUT,true);

	SetMenu(hMain,menu->hMenu);

	hPropsheet = create_propsheet();
	if(hPropsheet == INVALID_HANDLE_VALUE)
	{
		WINERROR("Property sheet creation failed.");
		ExitProcess(0);
	}

	SetWindowLong(hPropsheet, GWL_STYLE, WS_CHILD);
	SetParent(hPropsheet,hMain);
	SetWindowLong(hPropsheet, GWL_EXSTYLE, WS_EX_CONTROLPARENT);

	init_propsheet_size();

	SetTimer(hMain, 777, 1000, NULL);
	dwTimerOf = GetTickCount();

	DragAcceptFiles(hMain,TRUE);

	hStatus = CreateStatusWindow(WS_CHILD|WS_VISIBLE,"",hMain,1555);

	ShowWindow(hMain,SW_SHOW);
	ShowWindow(hSubScr,SW_SHOW);

	GetWindowRect(hMain,&rect);
	force_window_size(hSubScr,rect.right+24,rect.top,256,384);


	UpdateWindow(hSubScr);
	UpdateWindow(hMain);


    hSysMenu = GetSystemMenu(hSubScr, 0);
	EnableMenuItem(hSysMenu, SC_CLOSE, (MF_BYCOMMAND|MF_GRAYED));


	bmp_config(BMP_FLIP, BMP_DONT_FLIP);
	bmp_config(BMP_HEADER, BMP_HEADER);
	bmp_config(BMP_PALETTE, BMP_PALETTE);
	bmp_config(BMP_ALIGN, BMP_ALIGN);


	init();


	// Try to load a rom if one was specified on the commandline
	if (strlen(lpCmdLine))
	{
		// Handle quoted filenames from explorer
		if (romName[0] == '\"')
		{
			romName[strlen(romName)-1] = '\0';
			romName++;
			strcpy(szBuffer3,romName);
		}
		else if (!((strchr(romName,':')!=NULL) || (romName[0]=='\\')))
		{
			wsprintf(szBuffer3,"%s\\%s",currDir,romName);
		} else
		{
			strcpy(szBuffer3,romName);
		}
		//MessageBox(NULL,szBuffer,"Foo",MB_OK);
		cart = load_rom(szBuffer3);
		if (cart)
		{
			SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)romName);
			wsprintf(szBuffer,"Loaded ROM: %s",romName);
			hub(TELL,ZOMBIE_DEBUG_MSG,szBuffer,0);
			romLoaded = true;
			reset_machine(true);
			run = true;
		} else
		{
			SendMessage(hStatus,SB_SETTEXT,1,(LPARAM)"No ROM loaded");
			run = false;
		}
	}

	colors[0] = GetPrivateProfileInt("Colors","ColorBackground",0xFFFFFF,iniFn);
	colors[1] = GetPrivateProfileInt("Colors","ColorAddress",0x909090,iniFn);
	colors[2] = GetPrivateProfileInt("Colors","ColorMnemonic",0x0000FF,iniFn);
	colors[3] = GetPrivateProfileInt("Colors","ColorRegister",0x000090,iniFn);
	colors[4] = GetPrivateProfileInt("Colors","ColorImmediate",0x808010,iniFn);
	colors[5] = GetPrivateProfileInt("Colors","ColorComment",0x009000,iniFn);
	colors[6] = GetPrivateProfileInt("Colors","ColorBracket",0xFF0000,iniFn);
	colors[7] = GetPrivateProfileInt("Colors","ColorText",0x000000,iniFn);

	for (i=0; i<8; i++)
		colors[i] = RGB2BGR(colors[i]);

	haccel = LoadAccelerators(hInst,(LPCSTR)MAKEINTRESOURCE(IDR_ACCELERATOR1));

	/*lpfnOldWndProc = (DWORD*)SetWindowLong(hMain,GWL_WNDPROC,(DWORD)input_proc);
	if (lpfnOldWndProc==NULL)
	{
		WINERROR("SetWindowLong failed");
		ExitProcess(0);
	}*/

	while (!quit)
	{
		idle();
		emulate();
	}

	shut_down();

	return msg.wParam;
}
